(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("styled-components"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "styled-components"], factory);
	else if(typeof exports === 'object')
		exports["Subatomic"] = factory(require("react"), require("styled-components"));
	else
		root["Subatomic"] = factory(root["react"], root["styled-components"]);
})(typeof self !== 'undefined' ? self : this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_10__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 9);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSubatomic = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = __webpack_require__(0);

var _react2 = _interopRequireDefault(_react);

var _blacklistedStyleProps = __webpack_require__(2);

var _blacklistedStyleProps2 = _interopRequireDefault(_blacklistedStyleProps);

var _pseudoclasses = __webpack_require__(3);

var _pseudoclasses2 = _interopRequireDefault(_pseudoclasses);

var _default = __webpack_require__(4);

var _default2 = _interopRequireDefault(_default);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isBlacklistedStyleProp = function isBlacklistedStyleProp(prop) {
  return _blacklistedStyleProps2.default.indexOf(prop) >= 0;
};

var customPropsCached = void 0;

// Cache for styled components (so we're not creating new ones on each render)
var Cache = createCache();

var createSubatomic = function createSubatomic(tag, getComponent, isValidAttribute) {
  var defaultOptions = {
    themeBreakpointsKey: 'breakpoints',
    tagProp: 'is'
  };

  var options = defaultOptions;

  // TODO: Let consumer pass in custom options to createSubatomic
  /*if (options) {
    options = Object.assign(defaultOptions, options);
  } else {
    options = defaultOptions;
  }*/

  // The returned stateless functional component
  var Subatomic = function Subatomic(_ref) {
    var allProps = _objectWithoutProperties(_ref, []);

    // Destructure tagProp from props and assign value to "is" variable
    var is = allProps[options.tagProp],
        props = _objectWithoutProperties(allProps, [options.tagProp]);

    // "is" prop overrides tag so we can change element


    if (is) {
      tag = is;
    }

    // Will be the returned react component
    var Component = getComponentWithCache(tag, options, getComponent, isValidAttribute);

    // Save Component to cache
    Cache.put(tag, Component);

    return _react2.default.createElement(Component, props);
  };

  return Subatomic;
};

exports.createSubatomic = createSubatomic;
function getComponentWithCache(tag, options, getComponent, isValidAttribute) {
  // Get component from cache by its tag (tag can be string or function reference)
  var CachedComponent = Cache.get(tag);
  if (CachedComponent) {
    return CachedComponent;
  }

  var styleBuilder = createStyleBuilder(options, isValidAttribute);

  // Get the cache index Component will have once it's added to cache
  // Used to create a deterministic hash for className (since will be same across server and client)
  // If tag is a string then value will be null (not needed)
  var referenceCacheIndex = null;
  if ((typeof tag === 'undefined' ? 'undefined' : _typeof(tag)) === 'object') {
    var cache = Cache.get();
    referenceCacheIndex = cache.byReference.keys.length;
  }

  var Component = getComponent(tag, styleBuilder, referenceCacheIndex);

  // Save Component to cache
  Cache.put(tag, Component);

  return Component;
}

function createStyleBuilder(options, isValidAttribute) {
  var styleBuilder = function styleBuilder(allProps) {
    // If theme passed via ThemeProvider then use it!
    // If not then allProps.theme will be an empty object
    var theme = void 0;
    if (isEmptyObject(allProps.theme) === false) {
      theme = allProps.theme;
    } else if (!theme) {
      // Otherwise use our basic default theme
      theme = _default2.default;
    }

    var customProps = void 0;
    if (customPropsCached) {
      customProps = customPropsCached;
    } else {
      customProps = createPropVariations(theme.props);
      customPropsCached = customProps;
    }

    // TODO: memoize?
    var breakpoints = getBreakpoints(theme, options);

    var buildStyleFromObject = function buildStyleFromObject(props) {
      var fromPseudoClassObject = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var allStyles = {};

      // Iterate through the component's props

      var _loop = function _loop() {
        var prop = props[propName];
        var propType = typeof prop === 'undefined' ? 'undefined' : _typeof(prop);

        // Skip this style prop if blacklisted (not a style prop)
        // Or if not a custom style prop and it is a valid attribute
        if (isBlacklistedStyleProp(propName) || !customProps[propName] && isValidAttribute(propName)) {
          return 'continue';
        }

        // Get the prop's config
        var config = customProps[propName] || propName;

        // Make config an object if string
        // Could be string if using shorthand or values in pseudoClass style
        if (typeof config === 'string') {
          config = {
            style: config
          };
        }

        // See if prop is a pseudoclass (hoverColor, hoverPlaceholderColor)
        // Skip if custom style prop in config
        if (!customProps[propName]) {
          var wasPseudoclass = false;
          // Iterate through pseudoclasses (also contains pseudoelements)
          for (var key in _pseudoclasses2.default) {
            var pseudo = key;
            // Check if string starts with pseudoclass
            if (propName.startsWith(pseudo)) {
              // Get the portion after the pseudoclass
              var remainder = propName.slice(pseudo.length);
              remainder = remainder.charAt(0).toLowerCase() + remainder.slice(1);
              // Prefix with : or :: depending on whether class or element
              var pseudoPrefixed = (_pseudoclasses2.default[key] === 'class' ? ':' : '::') + pseudo;
              // Recursively call build style on remaining portion as a prop
              var result = buildStyleFromObject(_defineProperty({}, remainder, prop), true);
              // Add to allStyles (or merge if already populated by another prop with same psuedoclass)
              if (allStyles[pseudoPrefixed]) {
                allStyles[pseudoPrefixed] = Object.assign(allStyles[pseudoPrefixed], result);
              } else {
                allStyles[pseudoPrefixed] = result;
              }

              wasPseudoclass = true;
              continue;
            }
          }

          // Continue because pseudoclass style already generated from recursive call
          if (wasPseudoclass) return 'continue';
        }

        // No longer doing pseudoclass object syntax
        /*
        if (config.pseudoClass) {
          allStyles[config.pseudoClass] = buildStyleFromObject(prop, true);
          continue;
        }
        */

        // Function that looks up prop value in theme
        var getFromTheme = function getFromTheme(value) {
          // Convert value to positive if a negative number
          var posValue = isNegative(value) ? value * -1 : value;
          // Construct dot notation key to actual value in theme
          var fullKey = config.themeKey + '.' + posValue;
          // Get value from theme
          var themeValue = get(theme, fullKey);
          // If value from theme is a number and input value was negative ...
          // ... then make the theme value negative
          if (isNegative(value) && isNumber(themeValue)) {
            themeValue = themeValue * -1;
          }
          return themeValue;
        };

        // Make props value an array if it's not
        var propValues = Array.isArray(prop) ? prop : [prop];

        // Iteration through props value array
        for (var i = 0; i < propValues.length; i++) {
          var propValue = propValues[i];

          // If no prop value is boolean true (example: <Flex wrap>)
          // Then set it to defaultValue if specified
          if (config.defaultValue && propValue === true) {
            propValue = config.defaultValue;
          }

          // Prop value might be a key for actual value in theme
          propValue = config.themeKey && getFromTheme(propValue) || propValue;

          // Append unit to propValue if number and defaultUnit specified
          if (config.defaultUnit && isNumber(propValue)) {
            propValue = '' + propValue + config.defaultUnit;
          }

          var styleObj = void 0;
          if (typeof config === 'string') {
            styleObj = makeStyle(propValue, config);
          } else if (typeof config.style === 'function') {
            styleObj = config.style(propValue, propName);
          } else {
            // Otherwise assume config.style is string or array
            styleObj = makeStyle(propValue, config.style);
          }

          if (i === 0) {
            // Merge with rest of component's styles
            Object.assign(allStyles, styleObj);
          } else {
            // Any prop values after the first get wrapped in media query
            var bp = breakpoints[i - 1];
            if (!allStyles[bp]) allStyles[bp] = {};
            Object.assign(allStyles[bp], styleObj);
          }
        }
      };

      for (var propName in props) {
        var _ret = _loop();

        if (_ret === 'continue') continue;
      }

      return allStyles;
    };

    return buildStyleFromObject(allProps);
  };

  return styleBuilder;
}

// Accepts a single css property (string) or multiple (array)
// Returns a style object with
function makeStyle(value, cssProperty) {
  var styleObj = {};
  // Ensure we have an array of css properties
  var cssProperties = Array.isArray(cssProperty) ? cssProperty : [cssProperty];
  // Iterate through cssProperties and build styleObj
  cssProperties.forEach(function (p) {
    return styleObj[p] = value;
  });
  return styleObj;
}

function createPropVariations(props) {
  for (var key in props) {
    var _prop = props[key];
    if (_prop.variations) {
      for (var vKey in _prop.variations) {
        var style = _prop.style,
            variations = _prop.variations,
            newProp = _objectWithoutProperties(_prop, ['style', 'variations']);

        newProp.style = variations[vKey];
        props[vKey] = newProp;
      }
    }
  }
  return props;
}

function getBreakpoints(theme, options) {
  return theme[options.themeBreakpointsKey].map(function (bp) {
    return '@media screen and (min-width: ' + bp + ')';
  });
}

function isNumber(value) {
  return typeof value === 'number' && !isNaN(value);
}

function isNegative(value) {
  return isNumber(value) && value < 0;
}

// Returns a cache object where key can be string or object/function reference
function createCache() {
  var cache = {
    byString: {},
    byReference: {
      keys: [],
      values: []
    }
  };
  return {
    put: function put(key, value) {
      if ((typeof key === 'undefined' ? 'undefined' : _typeof(key)) === 'object') {
        var index = cache.byReference.keys.indexOf(key);
        if (index === -1) {
          cache.byReference.keys.push(key);
          cache.byReference.values.push(value);
        } else {
          cache.byReference.values[index] = value;
        }
      } else {
        cache.byString[key] = value;
      }
    },
    get: function get(key) {
      if (!key) {
        return cache;
      } else if ((typeof key === 'undefined' ? 'undefined' : _typeof(key)) === 'object') {
        var index = cache.byReference.keys.indexOf(key);
        return cache.byReference.values[index];
      } else {
        return cache.byString[key];
      }
    }
  };
}

// lodash.get alternative (much smaller file size)
// From https://gist.github.com/jeneg/9767afdcca45601ea44930ea03e0febf
function get(obj, path, def) {
  var fullPath = path.replace(/\[/g, '.').replace(/]/g, '').split('.').filter(Boolean);

  return fullPath.every(everyFunc) ? obj : def;

  function everyFunc(step) {
    return !(step && (obj = obj[step]) === undefined);
  }
}

var isEmptyObject = function isEmptyObject(obj) {
  return Object.keys(obj).length === 0 && obj.constructor === Object;
};

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// Props that are neither attributes or style props
exports.default = [
// React
'theme', 'children',
// Subatomic Emotion
'parentClassName'];

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  active: 'class',
  checked: 'class',
  disabled: 'class',
  empty: 'class',
  enabled: 'class',
  focus: 'class',
  hover: 'class',
  invalid: 'class',
  required: 'class',
  target: 'class',
  valid: 'class',
  after: 'element',
  before: 'element',
  placeholder: 'element',
  selection: 'element'
};

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = {
  breakpoints: ['576px', '768px', '992px', '1200px'],
  space: [0, 4, 8, 16, 32, 64, 128, 256, 512],
  fontSizes: [12, 14, 16, 20, 24, 32, 48, 64, 72],
  // Custom style props go in the props object
  props: {
    f: {
      // Where to find values in theme
      themeKey: 'fontSizes',
      // Default unit if none specified
      defaultUnit: 'px',
      // Resulting css property
      style: 'fontSize'
    },
    color: {
      // Extend theme and add colors object
      themeKey: 'colors',
      style: 'color'
    },
    bg: {
      themeKey: 'colors',
      style: 'backgroundColor'
    },
    borderColor: {
      themeKey: 'colors',
      style: 'borderColor'
    },
    d: {
      style: 'display'
    },
    p: {
      themeKey: 'space',
      defaultUnit: 'px',
      style: 'padding',
      // Directional variations
      variations: {
        pt: 'paddingTop',
        pr: 'paddingRight',
        pb: 'paddingBottom',
        pl: 'paddingLeft',
        px: ['paddingLeft', 'paddingRight'],
        py: ['paddingTop', 'paddingBottom']
      }
    },
    m: {
      themeKey: 'space',
      defaultUnit: 'px',
      style: 'margin',
      variations: {
        mt: 'marginTop',
        mr: 'marginRight',
        mb: 'marginBottom',
        ml: 'marginLeft',
        mx: ['marginLeft', 'marginRight'],
        my: ['marginTop', 'marginBottom']
      }
    },
    h: {
      style: 'height'
    },
    // Advanced width prop
    w: {
      // Style is a function instead of a string
      style: function(value) {
        let width = value;
        // If less than 1 make it a fraction of 100% (1/3 = 33.33...%, etc)
        // Nice for column widths (<Row><Col w={1/3}><Col w={2/3}></Row>)
        if (isNumber(width) && width <= 1) {
          width = width * 100 + '%';
        }
        return {
          width: width
        };
      }
    }
  }
};

function isNumber(n) {
  return typeof n === 'number' && !isNaN(n);
}


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// These are valid attributes but we consider them style props instead
// TODO: Allow them to be passed to html element by doing attrColor
// TODO (?): Replace attribute whitelist with react-html-attributes so that attributes ...
// ... are considered invalid (and thus style props) if not valid for that element
// Then we could remove any of these where attribute has same effect as css property for the given element
// See how Glamorous does it: https://github.com/paypal/glamorous/blob/6d806889e9991065f1243d4abdce9c0b6cd3a2ae/src/should-forward-property.js
exports.default = ['color', // link, svg
'cursor', // svg
'display', // svg
'fontFamily', // svg
'fontSize', // svg
'fontStyle', // svg
'fontWeight', // svg
'height', // applet, canvas, embed, iframe, img, input, object, td, th, video
'width', // applet, canvas, col, colgroup, embed, hr, iframe, img, input, object, pre, table, td, th, video
'letterSpacing', // svg
'opacity', // svg
'order', // svg
'overflow', // svg
'size', // basefont, font, hr, input, select
'scale', // svg
'textDecoration', // svg
'transform' // svg
];

/***/ }),
/* 6 */,
/* 7 */,
/* 8 */,
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n    ', ';\n  '], ['\n    ', ';\n  ']);

var _react = __webpack_require__(0);

var _react2 = _interopRequireDefault(_react);

var _subatomic = __webpack_require__(1);

var _styledComponents = __webpack_require__(10);

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _validAttr = __webpack_require__(11);

var _validAttr2 = _interopRequireDefault(_validAttr);

var _blacklistedAttributes = __webpack_require__(5);

var _blacklistedAttributes2 = _interopRequireDefault(_blacklistedAttributes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// We can't import directly from styled-components/src because ...
// ... we'd want webpack to treat as external (not bundle with lib), but consuming project ...
// ... won't be able to parse depending on their babel/webpack. Also it breaks our lib if sc changes.
//import isHtmlAttribute from "styled-components/src/utils/validAttr";
// Exact copy of file above (minus flow types)
// We could wrap final element in styled() to filter out attributes (but performance hit?)
// Or we could use @emotion/is-prop-valid and bundle with lib since we're taking a file size hit anyway
// That way we at least use the same attribute filtering logic across style libs
// If we do that than move isValidAttribute() logic to subatomic.js
//import isHtmlAttribute from "@emotion/is-prop-valid";


exports.default = function (tag) {
  return function (props) {
    var Subatomic = createSubatomic(tag);
    return _react2.default.createElement(Subatomic, props);
  };
};

function createSubatomic(tag) {
  return (0, _subatomic.createSubatomic)(tag, getComponent,
  // We pass this in so that we can re-use emotion/sc whitelist for lower bundle size
  isValidAttribute);
}

function getComponent(tag, // string or component
styleBuilder, componentNumber) {
  var createStyled = void 0;

  if (typeof tag === 'string') {
    // We now filter using isValidAttribute()
    //const Root = styled(tag)``; // So whitelist filters out invalid element attributes

    var Filter = function Filter(props) {
      // Only pass props to DOM element if they are valid html attributes
      var next = {};
      for (var key in props) {
        if (isValidAttribute(key)) {
          next[key] = props[key];
        }
      }

      return _react2.default.createElement(tag, next);

      // No longer created a root element wrapped with styled() because we do filtering above
      //return React.createElement(Root, next);
    };

    // Manually setting displayName based on tag is necessary otherwise displayName will always be ...
    // ... hashed version of "createStyled" and may already have a "sc-component-id" comment marker in <head> ...
    // ... causing styled generated from props to be inserted above interpolated style ...
    // ... resulting in prop style being overriden.
    // NOTE: createStyled`${styleBuilder}` needs to be on its own line (like it is currently) ...
    // ... as opposed to doing styled(Filter).withConfig()`${styleBuilder}` otherwise there are ...
    // ... issues with style inheritance. Probably a bug with babel plugin.
    createStyled = (0, _styledComponents2.default)(Filter).withConfig({
      displayName: 'Tag-' + tag
    });
  } else {
    // This appears to work but to be safe sticking with original code for now
    // Pretty sure we ran into style inheritance issues that were solved by generating classname now ...
    // ... rather then in root subatomic element.
    //return tag;

    // Since we can't rely on tag (a function) to have a displayName ...
    // ... we use componentNumber (its future index in the component cache, same on both server and client)
    // This ensures that the same className hash is generated on both server and client
    // NOTE: Ideally we could just `return tag` here since prop style get regenerated at root anyway ...
    // ... but this caused css ordering issues
    createStyled = (0, _styledComponents2.default)(tag).withConfig({
      //displayName: `Tag()-${tag.displayName || 'unknown'}`
      displayName: 'Tag()-' + componentNumber
    });
  }

  return createStyled(_templateObject, styleBuilder);
}

function isValidAttribute(attribute) {
  return (0, _validAttr2.default)(attribute) && _blacklistedAttributes2.default.indexOf(attribute) === -1;
}

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_10__;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

/* eslint-disable max-len */
/**
 * Trying to avoid the unknown-prop errors on styled components by filtering by
 * React's attribute whitelist.
 *
 * To regenerate this regex:
 *
 * 1. `npm i -g regexgen` (https://github.com/devongovett/regexgen)
 * 2. Run `regexgen` with the list of space-separated words below as input
 * 3. Surround the emitted regex with this: `/^(GENERATED_REGEX)$/` -- this will ensure a full string match
 *    and no false positives from partials
 **/
/*
children dangerouslySetInnerHTML key ref autoFocus defaultValue valueLink defaultChecked checkedLink innerHTML suppressContentEditableWarning onFocusIn onFocusOut className onCopy onCut onPaste onCompositionEnd onCompositionStart onCompositionUpdate onKeyDown onKeyPress onKeyUp onFocus onBlur onChange onInput onInvalid onSubmit onReset onClick onContextMenu onDoubleClick onDrag onDragEnd onDragEnter onDragExit onDragLeave onDragOver onDragStart onDrop onMouseDown onMouseEnter onMouseLeave onMouseMove onMouseOut onMouseOver onMouseUp onSelect onTouchCancel onTouchEnd onTouchMove onTouchStart onScroll onWheel onAbort onCanPlay onCanPlayThrough onDurationChange onEmptied onEncrypted onEnded onError onLoadedData onLoadedMetadata onLoadStart onPause onPlay onPlaying onProgress onRateChange onSeeked onSeeking onStalled onSuspend onTimeUpdate onVolumeChange onWaiting onLoad onAnimationStart onAnimationEnd onAnimationIteration onTransitionEnd onCopyCapture onCutCapture onPasteCapture onCompositionEndCapture onCompositionStartCapture onCompositionUpdateCapture onKeyDownCapture onKeyPressCapture onKeyUpCapture onFocusCapture onBlurCapture onChangeCapture onInputCapture onSubmitCapture onResetCapture onClickCapture onContextMenuCapture onDoubleClickCapture onDragCapture onDragEndCapture onDragEnterCapture onDragExitCapture onDragLeaveCapture onDragOverCapture onDragStartCapture onDropCapture onMouseDownCapture onMouseEnterCapture onMouseLeaveCapture onMouseMoveCapture onMouseOutCapture onMouseOverCapture onMouseUpCapture onSelectCapture onTouchCancelCapture onTouchEndCapture onTouchMoveCapture onTouchStartCapture onScrollCapture onWheelCapture onAbortCapture onCanPlayCapture onCanPlayThroughCapture onDurationChangeCapture onEmptiedCapture onEncryptedCapture onEndedCapture onErrorCapture onLoadedDataCapture onLoadedMetadataCapture onLoadStartCapture onPauseCapture onPlayCapture onPlayingCapture onProgressCapture onRateChangeCapture onSeekedCapture onSeekingCapture onStalledCapture onSuspendCapture onTimeUpdateCapture onVolumeChangeCapture onWaitingCapture onLoadCapture onAnimationStartCapture onAnimationEndCapture onAnimationIterationCapture onTransitionEndCapture accept acceptCharset accessKey action allowFullScreen allowTransparency alt as async autoComplete autoPlay capture cellPadding cellSpacing charSet challenge checked cite classID className cols colSpan content contentEditable contextMenu controlsList controls coords crossOrigin data dateTime default defer dir disabled download draggable encType form formAction formEncType formMethod formNoValidate formTarget frameBorder headers height hidden high href hrefLang htmlFor httpEquiv icon id inputMode integrity is keyParams keyType kind label lang list loop low manifest marginHeight marginWidth max maxLength media mediaGroup method min minLength multiple muted name nonce noValidate open optimum pattern placeholder playsInline poster preload profile radioGroup readOnly referrerPolicy rel required reversed role rows rowSpan sandbox scope scoped scrolling seamless selected shape size sizes span spellCheck src srcDoc srcLang srcSet start step style summary tabIndex target title type useMap value width wmode wrap about datatype inlist prefix property resource typeof vocab autoCapitalize autoCorrect autoSave color itemProp itemScope itemType itemID itemRef results security unselectable accentHeight accumulate additive alignmentBaseline allowReorder alphabetic amplitude arabicForm ascent attributeName attributeType autoReverse azimuth baseFrequency baseProfile baselineShift bbox begin bias by calcMode capHeight clip clipPath clipRule clipPathUnits colorInterpolation colorInterpolationFilters colorProfile colorRendering contentScriptType contentStyleType cursor cx cy d decelerate descent diffuseConstant direction display divisor dominantBaseline dur dx dy edgeMode elevation enableBackground end exponent externalResourcesRequired fill fillOpacity fillRule filter filterRes filterUnits floodColor floodOpacity focusable fontFamily fontSize fontSizeAdjust fontStretch fontStyle fontVariant fontWeight format from fx fy g1 g2 glyphName glyphOrientationHorizontal glyphOrientationVertical glyphRef gradientTransform gradientUnits hanging horizAdvX horizOriginX ideographic imageRendering in in2 intercept k k1 k2 k3 k4 kernelMatrix kernelUnitLength kerning keyPoints keySplines keyTimes lengthAdjust letterSpacing lightingColor limitingConeAngle local markerEnd markerMid markerStart markerHeight markerUnits markerWidth mask maskContentUnits maskUnits mathematical mode numOctaves offset opacity operator order orient orientation origin overflow overlinePosition overlineThickness paintOrder panose1 pathLength patternContentUnits patternTransform patternUnits pointerEvents points pointsAtX pointsAtY pointsAtZ preserveAlpha preserveAspectRatio primitiveUnits r radius refX refY renderingIntent repeatCount repeatDur requiredExtensions requiredFeatures restart result rotate rx ry scale seed shapeRendering slope spacing specularConstant specularExponent speed spreadMethod startOffset stdDeviation stemh stemv stitchTiles stopColor stopOpacity strikethroughPosition strikethroughThickness string stroke strokeDasharray strokeDashoffset strokeLinecap strokeLinejoin strokeMiterlimit strokeOpacity strokeWidth surfaceScale systemLanguage tableValues targetX targetY textAnchor textDecoration textRendering textLength to transform u1 u2 underlinePosition underlineThickness unicode unicodeBidi unicodeRange unitsPerEm vAlphabetic vHanging vIdeographic vMathematical values vectorEffect version vertAdvY vertOriginX vertOriginY viewBox viewTarget visibility widths wordSpacing writingMode x xHeight x1 x2 xChannelSelector xlinkActuate xlinkArcrole xlinkHref xlinkRole xlinkShow xlinkTitle xlinkType xmlBase xmlns xmlnsXlink xmlLang xmlSpace y y1 y2 yChannelSelector z zoomAndPan
*/
/* eslint-enable max-len */

var ATTRIBUTE_REGEX = /^((?:s(?:uppressContentEditableWarn|croll|pac)|(?:shape|image|text)Render|(?:letter|word)Spac|vHang|hang)ing|(?:on(?:AnimationIteration|C(?:o(?:mposition(?:Update|Start|End)|ntextMenu|py)|anPlayThrough|anPlay|hange|lick|ut)|(?:(?:Duration|Volume|Rate)Chang|(?:MouseLea|(?:Touch|Mouse)Mo|DragLea)v|Paus)e|Loaded(?:Metad|D)ata|(?:Animation|Touch|Load|Drag)Start|(?:(?:T(?:ransition|ouch)|Animation)E|Suspe)nd|DoubleClick|(?:TouchCanc|Whe)el|(?:Mouse(?:Ent|Ov)e|Drag(?:Ent|Ov)e|Erro)r|TimeUpdate|(?:E(?:n(?:crypt|d)|mpti)|S(?:tall|eek))ed|MouseDown|P(?:rogress|laying)|(?:MouseOu|DragExi|S(?:elec|ubmi)|Rese|Inpu)t|KeyPress|DragEnd|Key(?:Down|Up)|(?:Wait|Seek)ing|(?:MouseU|Dro)p|Scroll|Paste|Focus|Abort|Drag|Play|Load|Blur|Invalid)Captur|alignmentBaselin|(?:limitingConeAng|xlink(?:(?:Arcr|R)o|Tit)|s(?:urfaceSca|ty|ca)|unselectab|baseProfi|fontSty|(?:focus|dragg)ab|multip|profi|tit)l|d(?:ominantBaselin|efaultValu)|a(?:uto(?:Capitaliz|Revers|Sav)|dditiv)|(?:(?:formNoValid|xlinkActu|noValid|accumul|rot)a|autoComple|decelera)t|(?:(?:attribute|item)T|datat)yp|(?:attribute|glyph)Nam|playsInlin|(?:formE|e)ncTyp|(?:writing|input|edge)Mod|(?:xlinkTy|itemSco|keyTy|slo)p|(?:amplitu|mo)d|(?:xmlSpa|non)c|fillRul|(?:dateTi|na)m|r(?:esourc|ol)|xmlBas|wmod)e|(?:glyphOrientationHorizont|loc)al|(?:externalResourcesRequir|select|revers|mut)ed|c(?:o(?:lorInterpolationFilter|ord)s|o(?:lor(?:Interpolation)?|nt(?:rols|ent))|(?:ontentS(?:cript|tyle)Typ|o(?:ntentEditab|lorProfi)l|l(?:assNam|ipRul)|a(?:lcMod|ptur)|it)e|olorRendering|l(?:ipPathUnits|assID)|(?:ontrolsLis|apHeigh)t|h(?:eckedLink|a(?:llenge|rSet)|ildren|ecked)|ell(?:Spac|Padd)ing|o(?:ntextMenu|ls)|(?:rossOrigi|olSpa)n|lip(?:Path)?|ursor|[xy])|glyphOrientationVertical|d(?:angerouslySetInnerHTML|efaultChecked|ownload|isabled|isplay|[xy])|(?:s(?:trikethroughThickn|eaml)es|(?:und|ov)erlineThicknes|r(?:equiredExtension|adiu)|(?:requiredFeatur|tableValu|stitchTil|numOctav|filterR)e|key(?:(?:Splin|Tim)e|Param)|autoFocu|header|bia)s|(?:(?:st(?:rikethroughPosi|dDevia)|(?:und|ov)erlinePosi|(?:textDecor|elev)a|orienta)tio|(?:strokeLinejo|orig)i|formActio|zoomAndPa|onFocusI|directio|(?:vers|act)io|rowSpa|begi|ico)n|o(?:n(?:AnimationIteration|C(?:o(?:mposition(?:Update|Start|End)|ntextMenu|py)|anPlayThrough|anPlay|hange|lick|ut)|(?:(?:Duration|Volume|Rate)Chang|(?:MouseLea|(?:Touch|Mouse)Mo|DragLea)v|Paus)e|Loaded(?:Metad|D)ata|(?:Animation|Touch|Load|Drag)Start|(?:(?:T(?:ransition|ouch)|Animation)E|Suspe)nd|DoubleClick|(?:TouchCanc|Whe)el|(?:Mouse(?:Ent|Ov)e|Drag(?:Ent|Ov)e|Erro)r|TimeUpdate|(?:E(?:n(?:crypt|d)|mpti)|S(?:tall|eek))ed|MouseDown|P(?:rogress|laying)|(?:MouseOu|DragExi|S(?:elec|ubmi)|Rese|Inpu)t|KeyPress|DragEnd|Key(?:Down|Up)|(?:Wait|Seek)ing|(?:MouseU|Dro)p|Scroll|Paste|Focus|Abort|Drag|Play|Load|Blur|Invalid)|rient)|p(?:reserveA(?:spectRatio|lpha)|ointsAt[X-Z]|anose1)|(?:patternContent|ma(?:sk(?:Content)?|rker)|primitive|gradient|pattern|filter)Units|(?:gradientT|patternT|t)ransform|(?:(?:allowTranspar|baseFrequ)enc|re(?:ferrerPolic|adOnl)|(?:(?:st(?:roke|op)O|floodO|fillO|o)pac|integr|secur)it|visibilit|fontFamil|accessKe|propert|summar)y|(?:strokeMiterlimi|(?:specularConsta|repeatCou|fontVaria)n|(?:(?:specularE|e)xpon|renderingInt|asc)en|d(?:iffuseConsta|esce)n|(?:fontSizeAdju|lengthAdju|manife)s|baselineShif|vectorEffec|(?:(?:mar(?:ker|gin)|x)H|accentH|fontW)eigh|a(?:utoCorrec|bou)|markerStar|onFocusOu|intercep|restar|forma|inlis|heigh|lis)t|(?:(?:st(?:rokeDasho|artO)|o)ffs|acceptChars|formTarg|viewTarg|srcS)et|(?:(?:enableBackgrou|markerE)n|s(?:p(?:readMetho|ee)|ee)|formMetho|m(?:arkerMi|etho)|preloa|kin)d|k(?:ernel(?:UnitLength|Matrix)|[1-4])|(?:[xy]ChannelSelect|lightingCol|textAnch|floodCol|stopCol|operat|htmlF)or|(?:allowFullScre|hidd)en|strokeDasharray|systemLanguage|(?:strokeLineca|itemPro|useMa|wra|loo)p|v(?:Mathematical|ert(?:Origin[XY]|AdvY)|alues|ocab)|(?:pointerEve|keyPoi)nts|unicodeRange|(?:(?:allowReord|placehold|frameBord|paintOrd|post|ord)e|repeatDu|d(?:efe|u))r|mathematical|(?:vI|i)deographic|h(?:oriz(?:Origin|Adv)X|ttpEquiv)|u(?:nicodeBidi|[12])|(?:fontStretc|hig)h|(?:(?:mar(?:ker|gin)W|strokeW)id|azimu)th|vAlphabetic|mediaGroup|spellCheck|(?:unitsPerE|optimu|fro)m|r(?:adioGroup|e(?:sults|f[XY]|l)|ows|[xy])|(?:xmlnsXl|valueL)ink|a(?:rabicForm|l(?:phabetic|t)|sync)|pathLength|(?:text|m(?:in|ax))Length|innerHTML|xlinkShow|(?:xlinkHr|glyphR)ef|r(?:e(?:quired|sult|f))?|o(?:verflow|pen)|(?:tabInde|(?:sand|b)bo|viewBo)x|(?:(?:href|xml|src)La|kerni)ng|f(?:o(?:ntSize|rm)|il(?:ter|l))|autoPlay|unicode|p(?:attern|oints)|t(?:arget[XY]|o)|i(?:temRef|n2|s)|divisor|d(?:efault|ata|ir)?|srcDoc|s(?:coped|te(?:m[hv]|p)|pan)|(?:width|size)s|(?:stri|la)ng|prefix|itemID|s(?:t(?:roke|art)|hape|cope|rc)|a(?:ccept|s)|t(?:arget|ype)|typeof|width|value|x(?:mlns)?|label|m(?:edia|a(?:sk|x)|in)|size|href|k(?:ey)?|end|low|x[12]|i[dn]|y[12]|g[12]|by|f[xy]|[yz])$/;

/* From DOMProperty */
var ATTRIBUTE_NAME_START_CHAR = ':A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD';
var ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + '\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040';
var isCustomAttribute = RegExp.prototype.test.bind(new RegExp('^(data|aria)-[' + ATTRIBUTE_NAME_CHAR + ']*$'));

exports.default = function (name) {
  return ATTRIBUTE_REGEX.test(name) || isCustomAttribute(name.toLowerCase());
};

/***/ })
/******/ ]);
});